/* -*- c++ -*-
 * Copyright (c) 2003-2007 The Ochusha Project.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 * $Id: constants.h,v 1.7 2007/01/01 03:17:25 fuyu Exp $
 */

#ifndef _LIBOCHUSHA_CONSTANTS_H_
#define _LIBOCHUSHA_CONSTANTS_H_

#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

#define OCHUSHA_BOARDLIST_XML		"boardlist.xml.gz"
#define OCHUSHA_BOOKMARKS_XML		"bookmarks.xml.gz"
#define OCHUSHA_CONFIG_XML		"config.xml.gz"
#define OCHUSHA_THREADLIST_XML		"threadlist.xml.gz"

#define OCHUSHA_DEFAULT_BBSMENU_URL_OLD	"http://www.ff.iij4u.or.jp/~ch2/bbsmenu.html"
#define OCHUSHA_DEFAULT_BBSMENU_URL	"http://menu.2ch.net/bbsmenu.html"
#define OCHUSHA_2CH_VIEWER_LOGIN_URL	"https://2chv.tora3.net/futen.cgi"
#define OCHUSHA_2CH_BE_LOGIN_URL	"http://be.2ch.net/test/login.php"


#if defined(PACKAGE) && defined(VERSION)
#define OCHUSHA_VERSION			PACKAGE "/" VERSION
#define OCHUSHA_USER_AGENT		"Monazilla/1.00 (" OCHUSHA_VERSION ")"
#define OCHUSHA_X_2CH_UA		OCHUSHA_VERSION
#else
#define OCHUSHA_USER_AGENT		"Monazilla/1.00 (anonymous)"
#define OCHUSHA_X_2CH_UA		"anonymous"
#endif
#define OCHUSHA_DOLIB_USER_AGENT	"DOLIB/1.00"


#define OCHUSHA_DEFAULT_THREADLIST_CHUNKSIZE	16384
#define OCHUSHA_DEFAULT_THREAD_CHUNKSIZE	16384
#define OCHUSHA_DEFAULT_MISC_CHUNKSIZE		0x20000


#define HASSHINMOTO_UTF8 " \347\231\272\344\277\241\345\205\203:" // " ȯ:"

#define NAME_CP932	"\226\274\221\117\201\106"		// "̾"
#define DATE_CP932	"\223\212\215\145\223\372\201\106"	// ""


// "񤭹"
#define KAKIKOMU_CP932_URIENC		"%%8F%%91%%82%%AB%%8D%%9E%%82%%DE"
#define KAKIKOMU_EUCJP_URIENC		"%%BD%%F1%%A4%%AD%%B9%%FE%%A4%%E0"

// "Ǥ餦Ȥƽ񤭹"
#define SHODAKU_KAKIKOMU_CP932_URIENC	"%%91%%53%%90%%D3%%94%%43%%82%%F0"\
					"%%95%%89%%82%%A4%%82%%B1%%82%%C6"\
					"%%82%%F0%%8F%%B3%%91%%F8%%82%%B5"\
					"%%82%%C4"\
					"%%8F%%91%%82%%AB%%8D%%9E%%82%%DE"
#define SHODAKU_KAKIKOMU_EUCJP_URIENC	"%%C1%%B4%%C0%%D5%%C7%%A4%%A4%%F2"\
					"%%C9%%E9%%A4%%A6%%A4%%B3%%A4%%C8"\
					"%%A4%%F2%%BE%%B5%%C2%%FA%%A4%%B7"\
					"%%A4%%C6"\
					"%%BD%%F1%%A4%%AD%%B9%%FE%%A4%%E0"

// "åǧ"
#define COOKIE_KAKUNIN_UTF8	"\343\202\257\343\203\203\343\202\255"\
				"\343\203\274"\
				"\347\242\272\350\252\215"\
				"\357\274\201"

// "Ƴǧ"
#define TOKO_KAKUNIN_UTF8	"\346\212\225\347\250\277"\
				"\347\242\272\350\252\215"


#ifdef __cplusplus
namespace Ochusha
{


  enum MailtoMode {
    MAILTO_MODE_DEFAULT = 0,
    MAILTO_MODE_SHOW,
    MAILTO_MODE_HIDE
  };


}
#endif

#endif	/* _LIBOCHUSHA_CONSTANTS_H_ */
