/* -*- c++ -*-
 * Copyright (c) 2003-2007 The Ochusha Project.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 * $Id: image_manager.h,v 1.15 2007/01/01 03:18:25 fuyu Exp $
 */

#ifndef _IMAGE_MANAGER_H_
#define _IMAGE_MANAGER_H_

#ifdef __cplusplus

#if defined(__GNUG__) && !defined(__ICC)
#pragma interface
#endif

#include "libochusha/cache_manager.h"
#include "libochusha/hashtable.h"
#include "libochusha/sigslot.h"
#include "libochusha/thread_pool.h"

#include "controller.h"

#include <vector>

#include <gtk/gtk.h>


using namespace std;
namespace Ochusha
{
  class ImageInfo;

  class ImageManager : public CacheManager
  {
    friend class ImageBuffer;
    friend class ImageInfo;

  private:
    Controller &controller;
    ThreadPool thread_pool;	// ɤ߽ФѥåɤȤ

    // ιgdk_threads_enter()ʴĶǹԤ٤
    CStringToPointerHashtable image_info_table;
    CStringToPointerHashtable a_bone_url_table;
    CStringToPointerHashtable a_bone_server_table;

    GSList *supported_format_list;
    vector<char *> supported_format_mime_types;

    ImageInfo *lookup_image_info(const char *url, int width, int height);


  public:
    ImageManager(Controller &controller);
    virtual ~ImageManager();

    // urlǻꤵ줿width x height˼ޤ礭˽̤᤿
    // ɽ뤿GtkImageؤΥݥ󥿤֤
    //
    // ܡ󤵤ƤˤNULL֤
    //
    // online⡼ɤǥåˤʤϡ̥åɤǥͥåȥ
    // 򳫻ϤǽŪˡꤵ줿⤷
    // GTK_STOCK_MISSING_IMAGEɽ褦GtkImageؤΥݥ󥿤
    // ֤
    //
    // offline⡼ɤǥåˤʤϡGTK_STOCK_MISSING_IMAGE
    // ɽƤGtkImageؤΥݥ󥿤֤
    //
    // ˤ衢ץꥱϤĤ֤GtkWidgetŪ
    // ǤȻפäɤ
    GtkWidget *get_widget(const char *url, int width, int height);

    void a_bone(const char *url);
    void a_bone_server(const char *url);

    bool is_a_boned(const char *url);
    bool is_image_link(const char *url);

    bool is_content_type_supported(const char *content_type);


    // ͥåȥβǡɤ߹߻ȯ롣
    // void output_log(const char *message);
    signal1<const char *> output_log;
  };


}


#endif	/* __cplusplus */

#endif	/* _IMAGE_MANAGER_H_ */
